Entity Search API - v7
The Bing Entity Search API returns entities.
Entities
Get entities and places results for a given query.
Select the testing console in the region where you created your resource:
Global West US West US 2 East US East US 2 West Central US South Central US West Europe North Europe Southeast Asia East Asia Australia East Brazil South Canada Central Central India UK South Japan East Central US France Central Korea Central Japan West North Central US South Africa NorthRequest URL
Request parameters
string
Query
string
The market where the results come from. Typically, this is the country where the user is making the request from; however, it could be a different country if the user is not located in a country where Bing delivers results. The market must be in the form 'language code-country code'. For example, en-US.
Full list of supported markets:
en-US
(optional)
number
The number of search results to return in the response. The actual number delivered may be less than requested.
(optional)
number
The zero-based offset that indicates the number of search results to skip before returning results.
(optional)
string
A filter used to filter results for adult content.
Request headers
string
Subscription key which provides access to this API. Found in your Cognitive Services accounts.
Request body
Response 200
{
"_type": "SearchResponse",
"queryContext": {
"originalQuery": "brad pitt"
},
"entities": {
"queryScenario": "DominantEntity",
"value": [
{
"contractualRules": [
{
"_type": "ContractualRules/LicenseAttribution",
"targetPropertyName": "description",
"mustBeCloseToContent": true,
"license": {
"name": "CC-BY-SA",
"url": "http://creativecommons.org/licenses/by-sa/3.0/"
},
"licenseNotice": "Text under CC-BY-SA license"
},
{
"_type": "ContractualRules/LinkAttribution",
"targetPropertyName": "description",
"mustBeCloseToContent": true,
"text": "en.wikipedia.org",
"url": "http://en.wikipedia.org/wiki/Brad_Pitt"
}
],
"webSearchUrl": "https://www.bing.com/search?q=Brad%20Pitt&filters=sid:%226d7d66a7-2cb8-0ae9-637c-f81fd749dc9a%22&location=lat%3a47.6717%3blong%3a-122.0937%3bdisp%3aRedmond%252C%2520Washington%3b",
"name": "Brad Pitt",
"description": "William Bradley Pitt is an American actor and producer. He has received multiple awards and nominations including an Academy Award as producer under his own company Plan B Entertainment.",
"entityPresentationInfo": {
"entityScenario": "DominantEntity",
"entityTypeHints": [
"Person"
]
},
"bingId": "6d7d66a7-2cb8-0ae9-637c-f81fd749dc9a"
}
]
}
}
Response 401
{
"error":{
"statusCode": 401,
"message": "Access denied due to invalid subscription key. Make sure you are subscribed to an API you are trying to call and provide the right key."
}
}
Response 403
{
"error":{
"statusCode": 403,
"message": "Out of call volume quota. Quota will be replenished in 2.12 days."
}
}
Response 429
{
"error":{
"statusCode": 429,
"message": "Rate limit is exceeded. Try again in 26 seconds."
}
}
Code samples
@ECHO OFF
curl -v -X GET "https://brazilsouth.api.cognitive.microsoft.com/bing/v7.0/entities/?q={string}&mkt=en-us&count=10&offset=0&safesearch=Moderate"
-H "Ocp-Apim-Subscription-Key: {subscription key}"
--data-ascii "{body}"
using System;
using System.Net.Http.Headers;
using System.Text;
using System.Net.Http;
using System.Web;
namespace CSHttpClientSample
{
static class Program
{
static void Main()
{
MakeRequest();
Console.WriteLine("Hit ENTER to exit...");
Console.ReadLine();
}
static async void MakeRequest()
{
var client = new HttpClient();
var queryString = HttpUtility.ParseQueryString(string.Empty);
// Request headers
client.DefaultRequestHeaders.Add("Ocp-Apim-Subscription-Key", "{subscription key}");
// Request parameters
queryString["q"] = "{string}";
queryString["mkt"] = "en-us";
queryString["count"] = "10";
queryString["offset"] = "0";
queryString["safesearch"] = "Moderate";
var uri = "https://brazilsouth.api.cognitive.microsoft.com/bing/v7.0/entities/?" + queryString;
var response = await client.GetAsync(uri);
}
}
}
// // This sample uses the Apache HTTP client from HTTP Components (http://hc.apache.org/httpcomponents-client-ga/)
import java.net.URI;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
public class JavaSample
{
public static void main(String[] args)
{
HttpClient httpclient = HttpClients.createDefault();
try
{
URIBuilder builder = new URIBuilder("https://brazilsouth.api.cognitive.microsoft.com/bing/v7.0/entities/");
builder.setParameter("q", "{string}");
builder.setParameter("mkt", "en-us");
builder.setParameter("count", "10");
builder.setParameter("offset", "0");
builder.setParameter("safesearch", "Moderate");
URI uri = builder.build();
HttpGet request = new HttpGet(uri);
request.setHeader("Ocp-Apim-Subscription-Key", "{subscription key}");
// Request body
StringEntity reqEntity = new StringEntity("{body}");
request.setEntity(reqEntity);
HttpResponse response = httpclient.execute(request);
HttpEntity entity = response.getEntity();
if (entity != null)
{
System.out.println(EntityUtils.toString(entity));
}
}
catch (Exception e)
{
System.out.println(e.getMessage());
}
}
}
<!DOCTYPE html>
<html>
<head>
<title>JSSample</title>
<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.9.0/jquery.min.js"></script>
</head>
<body>
<script type="text/javascript">
$(function() {
var params = {
// Request parameters
"q": "{string}",
"mkt": "en-us",
"count": "10",
"offset": "0",
"safesearch": "Moderate",
};
$.ajax({
url: "https://brazilsouth.api.cognitive.microsoft.com/bing/v7.0/entities/?" + $.param(params),
beforeSend: function(xhrObj){
// Request headers
xhrObj.setRequestHeader("Ocp-Apim-Subscription-Key","{subscription key}");
},
type: "GET",
// Request body
data: "{body}",
})
.done(function(data) {
alert("success");
})
.fail(function() {
alert("error");
});
});
</script>
</body>
</html>
#import <Foundation/Foundation.h>
int main(int argc, const char * argv[])
{
NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
NSString* path = @"https://brazilsouth.api.cognitive.microsoft.com/bing/v7.0/entities/";
NSArray* array = @[
// Request parameters
@"entities=true",
@"q={string}",
@"mkt=en-us",
@"count=10",
@"offset=0",
@"safesearch=Moderate",
];
NSString* string = [array componentsJoinedByString:@"&"];
path = [path stringByAppendingFormat:@"?%@", string];
NSLog(@"%@", path);
NSMutableURLRequest* _request = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:path]];
[_request setHTTPMethod:@"GET"];
// Request headers
[_request setValue:@"{subscription key}" forHTTPHeaderField:@"Ocp-Apim-Subscription-Key"];
// Request body
[_request setHTTPBody:[@"{body}" dataUsingEncoding:NSUTF8StringEncoding]];
NSURLResponse *response = nil;
NSError *error = nil;
NSData* _connectionData = [NSURLConnection sendSynchronousRequest:_request returningResponse:&response error:&error];
if (nil != error)
{
NSLog(@"Error: %@", error);
}
else
{
NSError* error = nil;
NSMutableDictionary* json = nil;
NSString* dataString = [[NSString alloc] initWithData:_connectionData encoding:NSUTF8StringEncoding];
NSLog(@"%@", dataString);
if (nil != _connectionData)
{
json = [NSJSONSerialization JSONObjectWithData:_connectionData options:NSJSONReadingMutableContainers error:&error];
}
if (error || !json)
{
NSLog(@"Could not parse loaded json with error:%@", error);
}
NSLog(@"%@", json);
_connectionData = nil;
}
[pool drain];
return 0;
}
<?php
// This sample uses the Apache HTTP client from HTTP Components (http://hc.apache.org/httpcomponents-client-ga/)
require_once 'HTTP/Request2.php';
$request = new Http_Request2('https://brazilsouth.api.cognitive.microsoft.com/bing/v7.0/entities/');
$url = $request->getUrl();
$headers = array(
// Request headers
'Ocp-Apim-Subscription-Key' => '{subscription key}',
);
$request->setHeader($headers);
$parameters = array(
// Request parameters
'q' => '{string}',
'mkt' => 'en-us',
'count' => '10',
'offset' => '0',
'safesearch' => 'Moderate',
);
$url->setQueryVariables($parameters);
$request->setMethod(HTTP_Request2::METHOD_GET);
// Request body
$request->setBody("{body}");
try
{
$response = $request->send();
echo $response->getBody();
}
catch (HttpException $ex)
{
echo $ex;
}
?>
########### Python 2.7 #############
import httplib, urllib, base64
headers = {
# Request headers
'Ocp-Apim-Subscription-Key': '{subscription key}',
}
params = urllib.urlencode({
# Request parameters
'q': '{string}',
'mkt': 'en-us',
'count': '10',
'offset': '0',
'safesearch': 'Moderate',
})
try:
conn = httplib.HTTPSConnection('brazilsouth.api.cognitive.microsoft.com')
conn.request("GET", "/bing/v7.0/entities/?%s" % params, "{body}", headers)
response = conn.getresponse()
data = response.read()
print(data)
conn.close()
except Exception as e:
print("[Errno {0}] {1}".format(e.errno, e.strerror))
####################################
########### Python 3.2 #############
import http.client, urllib.request, urllib.parse, urllib.error, base64
headers = {
# Request headers
'Ocp-Apim-Subscription-Key': '{subscription key}',
}
params = urllib.parse.urlencode({
# Request parameters
'q': '{string}',
'mkt': 'en-us',
'count': '10',
'offset': '0',
'safesearch': 'Moderate',
})
try:
conn = http.client.HTTPSConnection('brazilsouth.api.cognitive.microsoft.com')
conn.request("GET", "/bing/v7.0/entities/?%s" % params, "{body}", headers)
response = conn.getresponse()
data = response.read()
print(data)
conn.close()
except Exception as e:
print("[Errno {0}] {1}".format(e.errno, e.strerror))
####################################
require 'net/http'
uri = URI('https://brazilsouth.api.cognitive.microsoft.com/bing/v7.0/entities/')
uri.query = URI.encode_www_form({
# Request parameters
'q' => '{string}',
'mkt' => 'en-us',
'count' => '10',
'offset' => '0',
'safesearch' => 'Moderate'
})
request = Net::HTTP::Get.new(uri.request_uri)
# Request headers
request['Ocp-Apim-Subscription-Key'] = '{subscription key}'
# Request body
request.body = "{body}"
response = Net::HTTP.start(uri.host, uri.port, :use_ssl => uri.scheme == 'https') do |http|
http.request(request)
end
puts response.body